/**
 * App Event Handling
 * @namespace
 */
var app = {
    /**
     * Function overwritten in main.js, made to contain custom code for the app
     * @public
     */
    ready: function(){},
    /**
     * The first function that runs after page loads
     * @public
     */
    loaded: function(){},
    initialize: function() {
        this.bindEvents();
        nav.init();
        calc.content();
        document.querySelector("head title").innerText = config.appname;
        app.loaded();
        Comprobar();
        // LimpiarStorage();
    },
    setPlatformWeb: function(){
        var nua = navigator.userAgent.toLowerCase();
        var bodyElement = document.querySelector("body");

        if(nua.indexOf("android") > -1){
            bodyElement.setAttribute("platform", "android");
            if(nua.indexOf("chrome") == -1){
                out.error("FUCK IS ANDROID BROWSER");
                bodyElement.setAttribute("androidbrowser", "yes");
            }
        }else if(nua.indexOf("iphone") > -1 || nua.indexOf("ipad") > -1){
            bodyElement.setAttribute("platform", "ios");
            var start = nua.substr(nua.indexOf('os') + 2).trim();
            var v = parseInt(start.substr(0,start.indexOf("_")));
            if(v >= 7){
                bodyElement.setAttribute("gtios7", "true");
            }else{
                bodyElement.setAttribute("gtios7", "false");
            }
        }
    },
    setPlatformCordova: function(){
        if(typeof(device) != "undefined"){
            out.log("DEVICE Existe, aplicando plataforma");
            out.log(navigator.userAgent);
            var platform = device.platform.toLowerCase();
            var version = device.version;
            if(platform == "blackberry 10"){
                platform = "blackberry";
            }else if(platform == "wince"){
                platform == "windows";
            }
            out.log("Plataforma: " + platform);
            out.log("Version: " + version);
            var bodyElement = document.querySelector("body");
            bodyElement.setAttribute("platform", platform);
            bodyElement.setAttribute("fullversion", version);
            if(platform == 'ios'){
                if(parseInt(device.version.split('.')[0])){
                    bodyElement.setAttribute("gtios7", "true");
                }else{
                    bodyElement.setAttribute("gtios7", "false");
                }
            }
            bodyElement.setAttribute("version", version.split(".")[0]);
        }else{
            out.error("DEVICE No existe, no se puede aplicar plataforma");
        }
    },
    /**
     * Binds all the events to its handlers
     * @public
     */
    bindEvents: function() {
        document.addEventListener('deviceready',        this.onDeviceReady,    false);
        document.addEventListener('click',              this.onClickElement,   false);
        document.addEventListener('sgtouch',            this.onSGTouchElement, false);
        document.addEventListener('webkitAnimationEnd', this.onAnimEnd,        false);
        document.addEventListener('animationend',       this.onAnimEnd,        false);
        document.addEventListener('touchstart',         this.onTouchStart,     false);
        document.addEventListener('touchmove',          this.onTouchMove,      false);
        document.addEventListener('touchend',           this.onTouchEnd,       false);
        document.addEventListener('MSPointerDown',      this.onTouchStart,     false);
        document.addEventListener('MSPointerMove',      this.onTouchMove,      false);
        document.addEventListener('MSPointerUp',        this.onTouchEnd,       false);
        document.addEventListener('navin',              this.onNavin,          false);
        document.addEventListener('navout',             this.onNavout,         false);
        window.onresize = this.onWindowResize;

        out.log("Events binded");
    },
    unBindBack: function(){
        document.removeEventListener('backbutton', this.onBackButton, false);
    },
    bindBack: function(){
        document.addEventListener('backbutton', this.onBackButton, false);
    },
    /**
     * On touchstart event
     * @public
     */
    onTouchStart: function(e){
        var workingElement = e.target;
        var found = false;
        while(!found){
            if(workingElement.getAttribute("action") || workingElement.nodeName == "INPUT" || workingElement.nodeName == "TAB" || workingElement.nodeName == "A"){
                workingElement.cantrigger = true;
                workingElement.setAttribute("touching","true");
                found = true;
            }else if(workingElement.nodeName == "BODY"){
                found = true;
            }else{
                workingElement = workingElement.parentNode;
            }
        }
    },
    /**
     * On touchmove event
     * @public
     */
    onTouchMove: function(e){
        var workingElement = e.target;
        var found = false;
        while(!found){
            if(workingElement.cantrigger){
                workingElement.cantrigger = false;
                workingElement.setAttribute("touching","false");
                found = true;
            }else if(workingElement.nodeName == "BODY" || workingElement.nodeName == "TAB"){
                found = true;
            }else{
                workingElement = workingElement.parentNode;
            }
        }
    },
    /**
     * On touchend event
     * @public
     */
    onTouchEnd: function(e){
        var workingElement = e.target;
        var found = false;
        while(!found){
            if(workingElement.cantrigger){
                workingElement.setAttribute("touching","false");
                out.log('sgtouch triggered');
                var evsgt = document.createEvent('CustomEvent');
                evsgt.initCustomEvent('sgtouch',false,false,workingElement);
                document.dispatchEvent(evsgt);
                found = true;
            }else if(workingElement.nodeName == "BODY" || workingElement.nodeName == "TAB"){
                found = true;
            }else{
                workingElement = workingElement.parentNode;
            }
        }
    },
    /**
     * On click event
     * @public
     */
    onClickElement: function(e){
        e.stopPropagation();
        e.preventDefault();
    },
    /**
     * On deviceready event
     * @public
     */
    onDeviceReady: function() {
        out.log("DEVICE READY, API LOADED");
        app.setPlatformCordova();
        if(ComprobarPushListo()){
            push.register();
        }
        app.ready();
    },
    /**
     * On sgtouch SixGap special event, this event is equal to click in Mobile Browsers but without lag
     * @public
     */
    onSGTouchElement: function(e){
        if(app.loading.status){ return; }

        var workingElement = e.detail;

        out.log("onClickElement: Click on " + workingElement.nodeName);
        var found = false;

        while(!found){
            var actionAttr = workingElement.getAttribute("action");
            var mapid = workingElement.getAttribute("mapid");
            if(actionAttr && actionAttr != ""){
                var panelname = workingElement.getAttribute("panelname");
                out.log("onClickElement: Clicked element has an action");
                if(actionAttr == "back"){
                    out.log("onClickElement: Action back");
                    nav.goBack();
                }else if(actionAttr == "go"){
                    var gotoAttr = nav.alias.get(workingElement.getAttribute("goto"));
                    var ptitle = workingElement.getAttribute("title") || "";
                    if(gotoAttr && gotoAttr != ""){
                        if(utils.isURL(gotoAttr)){
                            ext.open(ptitle,gotoAttr);
                        }else{
                            nav.goTo(gotoAttr);
                        }
                    }
                }else if(actionAttr == "refresh" && mapid != "" && mapid){
                    maps.refresh(mapid);
                }else if(actionAttr == "refresh" && panelname && panelname != ""){
                    ext.refresh(panelname);
                }else if(actionAttr == "link"){
                    var linkhref = workingElement.getAttribute("href");
                    if(linkhref || linkhref != "#"){
                        var target = workingElement.getAttribute("target");
                        if(!target){
                            target = '_blank';
                        }
                        if(target == '_blank' && document.querySelector('body').getAttribute('platform').toLowerCase() == "ios"){
                            target = '_system';
                        }
                        window.open(linkhref, target, 'location=yes');
                    }
                }else if(actionAttr == "savecontact"){
                    contact.saveContact();
                }else if(actionAttr == "saveevent"){
                    var _description = workingElement.getAttribute("description");
                    var _title = workingElement.getAttribute("title");
                    var _location = workingElement.getAttribute("location") || config.appname;
                    var _startdate = workingElement.getAttribute("startdate") || null;
                    var _enddate = workingElement.getAttribute("enddate") || null;
                    events.save(_title, _description, _location, _startdate, _enddate);
                }
                found = true;
            }else if(workingElement.nodeName == "INPUT"){
                if(workingElement.getAttribute("type") == "submit"){
                    while(workingElement.nodeName != "FORM" && workingElement.nodeName != "BODY"){
                        workingElement = workingElement.parentNode;
                    }
                    if(workingElement.nodeName == "FORM"){
                        contact.sendMail(workingElement);
                    }
                    found = true;
                }else if(workingElement.checked == true){
                    workingElement.checked = false;
                }else if(workingElement.checked == false){
                    workingElement.checked = true;
                }
                found = true;
            }else if(workingElement.nodeName == "A"){
                var linkhref = workingElement.getAttribute("href");
                if(linkhref.substr(0,6) == "mailto"){
                    window.location.href = linkhref;
                }else if(linkhref.substr(0,3) == "tel"){
                    window.location.href = linkhref;
                }else if(linkhref || linkhref != "#"){
                    window.open(linkhref, '_blank', 'location=yes');
                }
                found = true;
            }else if(workingElement.nodeName == "BODY"){
                found = true;
            }else if(workingElement.nodeName == "TAB"){
                var firstpanel = nav.alias.get(workingElement.getAttribute("firstpanel"));
                if(utils.isURL(firstpanel)){
                    var ptitle = workingElement.getAttribute("title");
                    ext.open(ptitle, firstpanel, workingElement.getAttribute("name"));
                }else if(firstpanel){
                    nav.changeTo(workingElement.getAttribute("name"));
                }
                found = true;
            }else{
                workingElement = workingElement.parentNode;
                out.log("No encontrado, siguiente: "+workingElement.nodeName);
            }
        }
        workingElement.setAttribute("badge","off");
    },
    /**
     * On animation end event
     * @public
     */
    onAnimEnd: function(e){
        var nodeName = e.target.nodeName;
        var status = e.target.getAttribute("status");
        if(nodeName == "PANEL"){
            if(status == "show" || status == "showBack"){
                if(navigator.appName == "Microsoft Internet Explorer"){
                    var evt = document.createEvent("CustomEvent");
                    evt.initEvent("navin",true,false);
                    evt.element = e.target;
                }else{
                    try {
                        var evt = new CustomEvent("navin", {detail:e.target});
                    }catch(err){
                        var evt = document.createEvent("CustomEvent");
                        evt.initEvent("navin",true,false);
                        evt.element = e.target;
                    }
                    
                }
                document.dispatchEvent(evt);
                e.target.setAttribute("status","shown");
            }else if(status == "hide" || status == "hideBack"){
                if(navigator.appName == "Microsoft Internet Explorer"){
                    var evt = document.createEvent("CustomEvent");
                    evt.initEvent("navout",true,false);
                    evt.element = e.target;
                }else{
                    try {
                        var evt = new CustomEvent("navout", {detail:e.target});
                    }catch(err){
                        var evt = document.createEvent("CustomEvent");
                        evt.initEvent("navout",true,false);
                        evt.element = e.target;
                    }
                }
                document.dispatchEvent(evt);
                e.target.setAttribute("status","hidden");
            }
        }
    },
    /**
     * On event reveived event
     * @public
     */
    receivedEvent: function(id) {
        out.log('Received Event: ' + id);
    },
    onNavin: function(e){
        var panel = e.detail || e.element;
        if(panel.getAttribute("type") == "map"){
            maps.init(panel.getAttribute("name"));
        }
    },
    onNavout: function(){
        
    },
    /**
     * On resize event
     * @public
     */
    onWindowResize: function(){
        // Every time the window is resized, re-calctulate the content height
        calc.content();
    },
    onBackButton: function(e){
        nav.goBack();
        e.preventDefault();
    },
    loading: {
        status: false,
        on: function(){
            document.querySelector("loading").className = "active";
            app.loading.status = true;
        },
        off: function(){
            document.querySelector("loading").className = "";
            app.loading.status = false;
        }
    }
};