var push = {
	received: function(push){},
	plugin: null,
	bindPlugin: function(){
		try {
			if(typeof(window.plugins.pushNotification) != "undefined"){
				push.plugin = window.plugins.pushNotification;
				out.log("PushPlugin cargado");
			}else{
				out.error("PushPlugin no cargado");
			}
		} catch (err) {
			out.error(err);
		}
	},
	register: function(){
		push.bindPlugin();
		if (device.platform == 'android' || device.platform == 'Android'){
		    push.plugin.register(
		        push.successHandler,
		        push.errorHandler, {
		            "senderID":config.senderID,
		            "ecb":"PushOnGCM"
		        });
		}else{
		    push.plugin.register(
		        push.tokenHandler,
		        push.errorHandler, {
		            "badge":"true",
		            "sound":"true",
		            "alert":"true",
		            "ecb":"PushOnAPN"
		        });
		}
	},
	successHandler: function(res){
		out.log("Push: " + res);
	},
	errorHandler: function(err){
		out.error("Push: "+ err);
	},
	tokenHandler: function(token){
		if(config.pushRegisterURL){
			utils.ping(config.pushRegisterURL + "?appuser=" + config.backoffice_user + "&platform=ios&token=" + token + "&Nombre=" + window.localStorage.getItem("username") + "&email=" + window.localStorage.getItem("email") + "&Categoría=" + window.localStorage.getItem("categories") + "&Provincia=" + window.localStorage.getItem("seleccion"));
		}else{
			utils.ping("http://seiscocos.com/6gapapi/v1/push/register.php?pid=" + config.appid + "&platform=ios&token=" + token);
		}
		out.log("Push: Token: " + token);
	},
	onNotificationAPN: function(e){
		if (e.alert) {
	        push.received(e);
	    }
	    if (e.badge) {
	        push.plugin.setApplicationIconBadgeNumber(push.successHandler, push.errorHandler, e.badge);
	    }
	},
	onNotificationGCM: function(e){
		out.log("Push: New GCM Event");
		out.log("Push: GCM Event: " + e.event);
		switch(e.event) {

		    case 'registered':
		        if (e.regid.length > 0) {
		        	if(config.pushRegisterURL){
						utils.ping(config.pushRegisterURL + "?appuser=" + config.backoffice_user + "&platform=android&token=" + e.regid + "&Nombre=" + window.localStorage.getItem("username") + "&email=" + window.localStorage.getItem("email") + "&Categoría=" + window.localStorage.getItem("categories") + "&Provincia=" + window.localStorage.getItem("seleccion"));
					}else{
						utils.ping("http://seiscocos.com/6gapapi/v1/push/register.php?pid=" + config.appid + "&platform=android&token=" + e.regid);
					}
		            out.log("Push: Token: " + e.regid);
		        }
		    break;

		    case 'message':
		        // if this flag is set, this notification happened while we were in the foreground.
		        // you might want to play a sound to get the user's attention, throw up a dialog, etc.
		        if (e.foreground) {
		            out.log("Push: Notificación foreground");
		        }else{
		          // otherwise we were launched because the user touched a notification in the notification tray.
		            if (e.coldstart) {
		                out.log("Push: Notificación coldstart");
		            }else{
		                out.log("Push: Notificación background");
		            }
		        }

		        push.received(e.payload);
		    break;

		    case 'error':
		        out.error("Push: GCM: " + e.msg);
		    break;

		    default:
		        out.error("Push: GCM: Something happened");
		    break;
		}
	}
}

function PushOnGCM(e){
	push.onNotificationGCM(e);
}

function PushOnAPN(e){
	push.onNotificationAPN(e);
}