var templates = {
	cache: {},
	apply: function(tname, context, callback){
		if(templates.cache[tname]){
			var source = templates.cache[tname];
			var template = Handlebars.compile(source);
			var html = template(context);
			callback(html);
		}else{
			xhr = new XMLHttpRequest();
			xhr.onreadystatechange = function(){
				if (xhr.readyState == 4 && xhr.response != "") {
					var source = xhr.responseText;
					var template = Handlebars.compile(source);
					var html = template(context);
					templates.cache[tname] = xhr.responseText;
					callback(html);
				}
			}
			xhr.open("GET","templates/"+tname+".html",true);
			xhr.send();
		}
	}
}

Handlebars.registerHelper('twitterBigAvatar', function(avatar) {
	return avatar.replace("_normal","_bigger");
});

Handlebars.registerHelper('parseTwit', function(twit) {
	return utils.parseTwit(twit);
});

Handlebars.registerHelper('firstPhotoURL', function(photos) {
	return photos[0].url;
});

Handlebars.registerHelper('twitImages', function(twit) {
	return utils.twitImages(twit);
});

Handlebars.registerHelper('twitVideos', function(twit) {
	return utils.twitVideos(twit);
});

Handlebars.registerHelper('prettyDate', function(date) {
	return utils.prettyDate(date);
});

Handlebars.registerHelper('count', function(e) {
	return e.length;
});

Handlebars.registerHelper('bigPhoto', function(image) {
	return image.replace("_s.","_b.");
});

Handlebars.registerHelper('equals', function(c1,c2,options) {
	if(c1 == c2){
		return options.fn(this);
	}else{
		return options.inverse(this);
	}
});

Handlebars.registerHelper('validStatus', function(options) {
	console.log(this);
	if(this.type == 'status' && !(this.message) && !(this.story) ){
		// Nothing
	}else{
		return options.fn(this);
	}
});

Handlebars.registerHelper('esLista', function(c1,options) {
	if( Array.isArray(c1)){
		return options.fn(this);
	}else{
		return options.inverse(this);
	}
});

Handlebars.registerHelper('hayDesc', function(desc) {
	var salida = "";
	var a = desc.substring(0, 4); // var a = desc[0] + desc[1] + desc[2] + desc[3];
	out.log("Tamaño Descripción: " + desc.length); out.log(a);

	if(a != '<p><' && a != '<spa' && desc.length > 244) // Así indico que en la descripción existe realmente texto.
	{
		salida = "<div class=\"box\" style='border:0px;'>"+desc+"</div>";
	}

	return salida;
});

Handlebars.registerHelper('backoffice_user', function() {
	return config.backoffice_user;
});

Handlebars.registerHelper('albumtype', function() {
	console.log("%calbumtype handlerbars " + abt, "color;red;");
	return abt;
});


// http://doginthehat.com.au/2012/02/comparison-block-helper-for-handlebars-templates/
// Handlebars.registerHelper('compare', function(lvalue, rvalue, options) {

//     if (arguments.length < 3)
//         throw new Error("Handlerbars Helper 'compare' needs 2 parameters");

//     operator = options.hash.operator || "==";

//     var operators = {
//         '==':       function(l,r) { return l == r; },
//         '===':      function(l,r) { return l === r; },
//         '!=':       function(l,r) { return l != r; },
//         '<':        function(l,r) { return l < r; },
//         '>':        function(l,r) { return l > r; },
//         '<=':       function(l,r) { return l <= r; },
//         '>=':       function(l,r) { return l >= r; },
//         'typeof':   function(l,r) { return typeof l == r; }
//     }

//     if (!operators[operator])
//         throw new Error("Handlerbars Helper 'compare' doesn't know the operator "+operator);

//     var result = operators[operator](lvalue,rvalue);

//     if( result ) {
//         return options.fn(this);
//     } else {
//         return options.inverse(this);
//     }
// });

// Handlebars.registerHelper('equal', function(lvalue, rvalue, options) {
//     if (arguments.length < 3)
//         throw new Error("Handlebars Helper equal needs 2 parameters");
//     if( lvalue!=rvalue ) {
//         return options.inverse(this);
//     } else {
//         return options.fn(this);
//     }
// });