var Scroll = {
	startY: 0,
	startScroll: 0,
	prevented: false,
	heightCount: 0,
	init: function(){

		var selector = "*[sc-element]";

		var styleElement = document.createElement("style");
		styleElement.innerHTML = "div[sc-box]{background-color:#f0f0f0;overflow:hidden;height:0;box-shadow:inset 0 0 40px rgba(0,0,0,0.2);font-family:Arial} div[sc-box].slow{-webkit-transition:all .15s linear} div[sc-status]{display:none} div[sc-box].refresh div[sc-status=refresh],div[sc-box].up div[sc-status=up],div[sc-box].down div[sc-status=down]{display:block}";
		document.querySelector("body").appendChild(styleElement);

		document.querySelector(selector).addEventListener("touchstart", function(e){
			var el = document.querySelector(selector + " div[sc-box]");
			if(el.className == "refresh slow") { return; }
			Scroll.startY = e.touches[0].clientY;
			Scroll.startScroll = document.querySelector(selector).scrollTop;
			el.className = "up";
		}, false);

		document.querySelector(selector).addEventListener("touchmove", function(e){
			var el = document.querySelector(selector + " div[sc-box]");
			var limit = parseInt(document.querySelector(selector).getAttribute('sc-limit')) || 60;
			if(el.className == "refresh slow") { return; }
			if(e.touches[0].clientY >= Scroll.startY && Scroll.startScroll == 0){
				e.preventDefault();
				Scroll.heightCount = (e.touches[0].clientY - Scroll.startY)/2;
				
				el.style.height = Scroll.heightCount + "px";
				if(Scroll.heightCount >= limit){
					el.className = "down";
				}else{
					el.className = "up";
				}
				Scroll.prevented = true;
			}else if(Scroll.prevented == true){
				document.querySelector("body").scrollTop = Scroll.startY - e.touches[0].clientY;
			}
		}, false);

		document.querySelector(selector).addEventListener("touchend", function(e){
			var el = document.querySelector(selector + " div[sc-box]");
			if(el.className == "refresh slow") { return; }
			var limit = parseInt(document.querySelector(selector).getAttribute('sc-limit')) || 60;
			if(Scroll.heightCount >= limit){
				var te = document.querySelector(selector).getAttribute('sc-element');
				if(Scroll.elements[te]){
					Scroll.elements[te](function(){
						el.style.height = "0px";
						el.className = "refresh slow done";
					});
				}
				el.style.height = limit + "px";
				el.className = "refresh slow";
				Scroll.heightCount = 0;
			}else{
				el.style.height = "0px";
				el.className += " slow";
			}
			prevented = false;
		}, false);

	},
	onRefresh: function(name, callback){
		Scroll.elements[name] = callback;
	},
	elements: []
}